Bug 3858 (int-93389)

Summary: maemo-launcher build-depends on libhildondesktop-dev, which in turn build-depends on maemo-launcher-dev
Product: [Maemo Official Platform] System software Reporter: Carsten Munk <carsten.munk>
Component: maemo-launcherAssignee: Guillem Jover <guillem>
Status: RESOLVED FIXED QA Contact: maemo-launcher-bugs
Severity: normal    
Priority: Low CC: andrey.kochanov, andre_klapper, carsten.munk, eero.tamminen, quim.gil
Version: 5.0-alpha-pre2   
Target Milestone: 5.0-beta   
Hardware: All   
OS: Ubuntu   

Description Carsten Munk (reporter) maemo.org 2008-11-13 14:55:58 UTC
SOFTWARE VERSION:
Using trunk versions from https://stage.maemo.org/svn/maemo/projects/haf/trunk/

We are a small bunch of people from community trying to "reconstruct" Maemo
(see proposal at http://wiki.maemo.org/Maemo_Reconstructed, ), and we are
attempting a sort of proof of concept of this proposal. In this PoC we take
most published parts of Maemo and try to refit them onto a up-to-date
Debian/Ubuntu base to see what problems arise - also to help fix problems with
porting Debian/Ubuntu applications to the Maemo platform. 

As part of this work, we're reporting this bug to help improve Maemo and the
portability of the Maemo platform.

STEPS TO REPRODUCE THE PROBLEM:

dpkg-buildpackage'ing hildon-desktop

dpkg-buildpackage'ing maemo-launcher

EXPECTED OUTCOME:

Being able to compile each of these packages from bootstrap

ACTUAL OUTCOME:

maemo-launcher build-depends on libhildondesktop-dev, which in turn
build-depends on maemo-launcher-dev.

REPRODUCIBILITY:

Always.

EXTRA SOFTWARE INSTALLED:

Not applicable.

OTHER COMMENTS:

WORKAROUND:

in hildon-desktop:
DEB_BUILD_OPTIONS=nolauncher dpkg-buildpackage

dpkg -i built packages

in maemo-launcher:

dpkg-buildpackage

and then in hildon-desktop again:

dpkg-buildpackage.

User-Agent:       Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; .NET CLR
2.0.50727; .NET CLR 3.0.04506.30; InfoPath.1; .NET CLR 1.1.4322; .NET CLR
3.0.04506.648; .NET CLR 3.5.21022)
Comment 1 Carsten Munk (reporter) maemo.org 2008-11-13 15:10:14 UTC
.. and obviously a step in workaround where maemo-launcher-dev is dpkg -i'ed.
Comment 2 Quim Gil nokia 2008-11-17 09:05:20 UTC
CCing also Andrey as he is supervising the Fremantle architecture.
Comment 3 Eero Tamminen nokia 2008-11-18 13:07:16 UTC
Its the maemo-launcher Hildon booster (/usr/lib/maemo-launcher/booster-gtk.so)
that requires dependency to libhildondesktop-dev.  If it would be put to a
separate source package, build deps should work fine like this:
- libhildondesktop-dev -> maemo-launcher-dev
- maemo-launcher-hildon-booster -> libhildondesktop-dev, maemo-launcher-dev
Comment 4 Andre Klapper maemo.org 2008-11-18 18:23:40 UTC
I'm a bit lost here.
As this seems to be in the Desktop area and a non-critical issue (hence by
default a WONTFIX for Desktop as far as I understand), I'd really like to know
whether this still applies for Fremantle and whether it's worth to file an
internal ticket about this.

Comments appreciated (Andrey maybe?).
Comment 5 Guillem Jover nokia 2008-11-18 19:41:18 UTC
Just a note, cyclic Build-Depends are common in Debian, and that's one of
the first issue one stomps on when bootstrapping a new port for example,
but then they usually are not visible anymore. Of course those are desirable
to be fixed if feasible, but sometimes it's not. Consider pkg-config using
glib and glib needing pkg-config at build time, in that case pkg-config ships
an old snapshot of glib so that one can bootstrap it first.

(In reply to comment #3)
> Its the maemo-launcher Hildon booster  (/usr/lib/maemo-launcher/booster-gtk.so)
> that requires dependency to libhildondesktop-dev.  If it would be put to a
> separate source package, build deps should work fine like this:
> - libhildondesktop-dev -> maemo-launcher-dev
> - maemo-launcher-hildon-booster -> libhildondesktop-dev, maemo-launcher-dev

Yeah that'd be a possibility given the modular design of the launcher. Another
one would be to split the hildon-desktop from the library, and as I remember
there was already talk about that, maybe there's even an internal bug report.
Comment 6 Carsten Munk (reporter) maemo.org 2008-11-18 19:48:28 UTC
(In reply to comment #4)
> I'm a bit lost here.
> As this seems to be in the Desktop area and a non-critical issue (hence by
> default a WONTFIX for Desktop as far as I understand), I'd really like to know
> whether this still applies for Fremantle and whether it's worth to file an
> internal ticket about this.

It is true that it is a non-critical and trivial issue, but I don't agree that
because of this that it should be a WONTFIX. 

It is an issue that will improve Hildon (and launcher) adaptation outside of
Maemo, and may help in case of developers internally/externally bootstrapping
Maemo from scratch or in case of people using launcher in other distributions.

But in reply to #5 (thanks for the informative comment), yes, it's reasonable
to have some kind of circular dependancy in some cases - and even if this bug
would be a WONTFIX, it is now documented so future bootstrappers will be aware
this issue exists and can work with it.
Comment 7 Andre Klapper maemo.org 2008-11-20 20:46:42 UTC
Hmm, I assume this is worth importing to fix this for Fremantle?
Comment 8 Andre Klapper maemo.org 2008-11-24 14:12:55 UTC
Silence = compliance.

(In reply to comment #6)
> I don't agree that because of this that it should be a WONTFIX. 

Sorry, I've been misleading - I meant "WONTFIX for Diablo", but definitely NOT
for Fremantle.
Comment 9 Carsten Munk (reporter) maemo.org 2008-11-24 19:43:09 UTC
Definately WONTFIX for Diablo. My interest is in
stage.maemo.org/svn/maemo/projects/haf/trunk/maemo-launcher personally, - a fix
at some point would be most welcome, but not critical for SDK or actual
release.
Comment 10 Carsten Munk (reporter) maemo.org 2009-05-07 12:25:46 UTC
Seems to be fixed in Fremantle Beta, as libhildondesktop is seperated out from
hildon-desktop. Still a pain for us as we use the old HD. Does anyone happen to
know if beta libhildondesktop is still usable for the old HD?
Comment 11 Andre Klapper maemo.org 2009-06-04 18:42:17 UTC
Internal comment:  "Circular dependency only seems to exist for old hildon
desktop (libhildondesktop0)"
Comment 12 Andre Klapper maemo.org 2009-09-17 01:06:10 UTC
(In reply to comment #10)
> Seems to be fixed in Fremantle Beta, as libhildondesktop is seperated out from
> hildon-desktop.

So can this be closed as FIXED?
Comment 13 Andre Klapper maemo.org 2009-09-28 16:24:33 UTC
Closing as per comment 10.